
#[derive(serde::Serialize, serde::Deserialize, Clone, Copy, Debug)]
pub struct Coords{
    pub lat:f64,
    pub lon:f64
}

#[derive(Clone, Copy, Debug, Hash, Default)]
pub enum Service{OCCT, #[default]BC}


impl From<Service> for &'static str{
    fn from(value: Service) -> Self {
        match value {
            Service::OCCT => "OCCT",
            Service::BC => "BC"
        }
    }
}

